class Country {
  int index;
  float latitude;
  float longitude;
  String name;
  String country_code;
  float x, y, z;
  
  float rice_x, rice_y, rice_z;
  float rice_supply = 0;
  IntList rice_connection;
  FloatList rice_consumption_data;
  float rice_self_consumption;
  
  float wheat_x, wheat_y, wheat_z;
  float wheat_supply = 0;
  IntList wheat_connection;
  FloatList wheat_consumption_data;
  float wheat_self_consumption;
  
  float other_cereal_x, other_cereal_y, other_cereal_z;
  float other_cereal_supply = 0;
  IntList other_cereal_connection;
  FloatList other_cereal_consumption_data;
  float other_cereal_self_consumption;
  
  float vegitable_x, vegitable_y, vegitable_z;
  float vegitable_supply = 0;
  IntList vegitable_connection;
  FloatList vegitable_consumption_data;
  float vegitable_self_consumption;
  
  float oil_x, oil_y, oil_z;
  float oil_supply = 0;
  IntList oil_connection;
  FloatList oil_consumption_data;
  float oil_self_consumption;
  
    
  float sugar_x, sugar_y, sugar_z;
  float sugar_supply = 0;
  IntList sugar_connection;
  FloatList sugar_consumption_data;
  float sugar_self_consumption;
  
  boolean should_display = true;

  Country(int index, String country_code, String name, float latitude, float longitude, 
  float rice_supply, float wheat_supply, float other_cereal_supply,
  float vegitable_supply, float oil_supply, float sugar_supply ) {
    this.index = index;
    this.country_code = country_code;
    this.name = name;
    this.latitude = latitude;
    this.longitude = longitude;
    this.latitude = map(latitude, -90, 90, -HALF_PI, HALF_PI);
    this.longitude = map(longitude, -180, 180, -PI, PI);
    this.rice_supply = rice_supply;
    this.wheat_supply = wheat_supply;
    this.other_cereal_supply = other_cereal_supply;
    this.vegitable_supply = vegitable_supply;
    this.oil_supply = oil_supply;
    this.sugar_supply = sugar_supply;
    
    rice_connection = new IntList();
    rice_consumption_data = new FloatList();
    wheat_connection = new IntList();
    wheat_consumption_data = new FloatList();
    other_cereal_connection = new IntList();
    other_cereal_consumption_data = new FloatList();
    vegitable_connection = new IntList();
    vegitable_consumption_data = new FloatList();
    oil_connection = new IntList();
    oil_consumption_data = new FloatList();
    sugar_connection = new IntList();
    sugar_consumption_data = new FloatList();
    
    this.z = earth_radius * sin(this.latitude + HALF_PI ) * cos(this.longitude - HALF_PI);
    this.x = earth_radius * sin(this.latitude + HALF_PI ) * sin(this.longitude - HALF_PI);
    this.y = earth_radius * cos(this.latitude + HALF_PI );
    this.rice_z = (sqrt(rice_supply)*5+earth_radius) * sin(this.latitude + HALF_PI ) * cos(this.longitude - HALF_PI);
    this.rice_x = (sqrt(rice_supply)*5+earth_radius) * sin(this.latitude + HALF_PI ) * sin(this.longitude - HALF_PI);
    this.rice_y = (sqrt(rice_supply)*5+earth_radius) * cos(this.latitude + HALF_PI );
    this.wheat_z = (sqrt(wheat_supply)*5+earth_radius) * sin(this.latitude + HALF_PI ) * cos(this.longitude - HALF_PI);
    this.wheat_x = (sqrt(wheat_supply)*5+earth_radius) * sin(this.latitude + HALF_PI ) * sin(this.longitude - HALF_PI);
    this.wheat_y = (sqrt(wheat_supply)*5+earth_radius) * cos(this.latitude + HALF_PI );
    this.other_cereal_z = (sqrt(other_cereal_supply)*5+earth_radius) * sin(this.latitude + HALF_PI ) * cos(this.longitude - HALF_PI);
    this.other_cereal_x = (sqrt(other_cereal_supply)*5+earth_radius) * sin(this.latitude + HALF_PI ) * sin(this.longitude - HALF_PI);
    this.other_cereal_y = (sqrt(other_cereal_supply)*5+earth_radius) * cos(this.latitude + HALF_PI );
    this.vegitable_z = (sqrt(vegitable_supply)*5+earth_radius) * sin(this.latitude + HALF_PI ) * cos(this.longitude - HALF_PI);
    this.vegitable_x = (sqrt(vegitable_supply)*5+earth_radius) * sin(this.latitude + HALF_PI ) * sin(this.longitude - HALF_PI);
    this.vegitable_y = (sqrt(vegitable_supply)*5+earth_radius) * cos(this.latitude + HALF_PI );
    this.oil_z = (sqrt(oil_supply)*5+earth_radius) * sin(this.latitude + HALF_PI ) * cos(this.longitude - HALF_PI);
    this.oil_x = (sqrt(oil_supply)*5+earth_radius) * sin(this.latitude + HALF_PI ) * sin(this.longitude - HALF_PI);
    this.oil_y = (sqrt(oil_supply)*5+earth_radius) * cos(this.latitude + HALF_PI );
    this.sugar_z = (sqrt(sugar_supply)*5+earth_radius) * sin(this.latitude + HALF_PI ) * cos(this.longitude - HALF_PI);
    this.sugar_x = (sqrt(sugar_supply)*5+earth_radius) * sin(this.latitude + HALF_PI ) * sin(this.longitude - HALF_PI);
    this.sugar_y = (sqrt(sugar_supply)*5+earth_radius) * cos(this.latitude + HALF_PI );
  }
  
  
  void draw_location() {
    noStroke();
    fill(100,100,100);
    pushMatrix();
    rotateY(HALF_PI * -1);
    rotateY(this.longitude);
    rotateX(this.latitude);
    translate(0, 0, 400);
    sphere(2);
    popMatrix();
  }
  
  void draw_connection(Country other_country) {
    strokeWeight(1);
    stroke(255);
    line(x, y, z, 
    other_country.x, other_country.y, other_country.z);
  }
  
 void draw_rice_connection(Country other_country) {
    if(show_individual){
      strokeWeight(3);
    }else{
      strokeWeight(1);
    }
    line(rice_x, rice_y, rice_z, 
    other_country.rice_x, other_country.rice_y, other_country.rice_z);
  }
  
  void draw_rice_self_consumption_() {
    noStroke();
    pushMatrix();
    translate(rice_x, rice_y, rice_z);
    sphere(sqrt(rice_supply)/4);
    popMatrix();
  }
  
  void draw_wheat_connection(Country other_country) {
    if(show_individual){
      strokeWeight(3);
    }else{
      strokeWeight(1);
    }
    line(wheat_x, wheat_y, wheat_z, 
    other_country.wheat_x, other_country.wheat_y, other_country.wheat_z);
  }
  
  void draw_wheat_self_consumption_() {
    noStroke();
    pushMatrix();
    translate(wheat_x, wheat_y, wheat_z);
    sphere(sqrt(wheat_supply)/4);
    popMatrix();
  }
  
  void draw_other_cereal_connection(Country other_country) {
    if(show_individual){
      strokeWeight(3);
    }else{
      strokeWeight(1);
    }
    line(other_cereal_x, other_cereal_y, other_cereal_z, 
    other_country.other_cereal_x, other_country.other_cereal_y, other_country.other_cereal_z);
  }
  
  void draw_other_cereal_self_consumption_() {
    noStroke();
    pushMatrix();
    translate(other_cereal_x, other_cereal_y, other_cereal_z);
    sphere(sqrt(other_cereal_supply)/4);
    popMatrix();
  }
  
  void draw_vegitable_connection(Country other_country) {
    if(show_individual){
      strokeWeight(3);
    }else{
      strokeWeight(1);
    }
    line(vegitable_x, vegitable_y, vegitable_z, 
    other_country.vegitable_x, other_country.vegitable_y, other_country.vegitable_z);
  }
  
  void draw_vegitable_self_consumption_() {
    noStroke();
    pushMatrix();
    translate(vegitable_x, vegitable_y, vegitable_z);
    sphere(sqrt(vegitable_supply)/4);
    popMatrix();
  }
  
  void draw_oil_connection(Country other_country) {
    if(show_individual){
      strokeWeight(3);
    }else{
      strokeWeight(1);
    }
    line(oil_x, oil_y, oil_z, 
    other_country.oil_x, other_country.oil_y, other_country.oil_z);
  }
  
  void draw_oil_self_consumption_() {
    noStroke();
    pushMatrix();
    translate(oil_x, oil_y, oil_z);
    sphere(sqrt(oil_supply)/4);
    popMatrix();
  }
  
  void draw_sugar_connection(Country other_country) {
    if(show_individual){
      strokeWeight(3);
    }else{
      strokeWeight(1);
    }
    line(sugar_x, sugar_y, sugar_z, 
    other_country.sugar_x, other_country.sugar_y, other_country.sugar_z);
  }
  
  void draw_sugar_self_consumption_() {
    noStroke();
    pushMatrix();
    translate(sugar_x, sugar_y, sugar_z);
    sphere(sqrt(sugar_supply)/4);
    popMatrix();
  }
}